diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-m-m.cc
--- a/libinterp/operators/op-m-m.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-m-m.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -48,7 +48,7 @@
 
 DEFUNOP (transpose, matrix)
 {
-  const octave_matrix& v = dynamic_cast<const octave_matrix&> (a);
+  const octave_matrix& v = DYNORSTAT_CAST<const octave_matrix&> (a);
 
   if (v.ndims () > 2)
     error ("transpose not defined for N-D objects");
@@ -69,8 +69,8 @@
 
 DEFBINOP (div, matrix, matrix)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
-  const octave_matrix& v2 = dynamic_cast<const octave_matrix&> (a2);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
+  const octave_matrix& v2 = DYNORSTAT_CAST<const octave_matrix&> (a2);
   MatrixType typ = v2.matrix_type ();
 
   Matrix ret = xdiv (v1.matrix_value (), v2.matrix_value (), typ);
@@ -86,8 +86,8 @@
 
 DEFBINOP (ldiv, matrix, matrix)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
-  const octave_matrix& v2 = dynamic_cast<const octave_matrix&> (a2);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
+  const octave_matrix& v2 = DYNORSTAT_CAST<const octave_matrix&> (a2);
   MatrixType typ = v1.matrix_type ();
 
   Matrix ret = xleftdiv (v1.matrix_value (), v2.matrix_value (), typ);
@@ -98,24 +98,24 @@
 
 DEFBINOP (trans_mul, matrix, matrix)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
-  const octave_matrix& v2 = dynamic_cast<const octave_matrix&> (a2);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
+  const octave_matrix& v2 = DYNORSTAT_CAST<const octave_matrix&> (a2);
   return octave_value(xgemm (v1.matrix_value (), v2.matrix_value (),
                              blas_trans, blas_no_trans));
 }
 
 DEFBINOP (mul_trans, matrix, matrix)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
-  const octave_matrix& v2 = dynamic_cast<const octave_matrix&> (a2);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
+  const octave_matrix& v2 = DYNORSTAT_CAST<const octave_matrix&> (a2);
   return octave_value(xgemm (v1.matrix_value (), v2.matrix_value (),
                              blas_no_trans, blas_trans));
 }
 
 DEFBINOP (trans_ldiv, matrix, matrix)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
-  const octave_matrix& v2 = dynamic_cast<const octave_matrix&> (a2);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
+  const octave_matrix& v2 = DYNORSTAT_CAST<const octave_matrix&> (a2);
   MatrixType typ = v1.matrix_type ();
 
   Matrix ret = xleftdiv (v1.matrix_value (), v2.matrix_value (),
@@ -138,8 +138,8 @@
 
 DEFBINOP (el_ldiv, matrix, matrix)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
-  const octave_matrix& v2 = dynamic_cast<const octave_matrix&> (a2);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
+  const octave_matrix& v2 = DYNORSTAT_CAST<const octave_matrix&> (a2);
 
   return octave_value (quotient (v2.array_value (), v1.array_value ()));
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-m-s.cc
--- a/libinterp/operators/op-m-s.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-m-s.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -48,8 +48,8 @@
 
 DEFBINOP (div, matrix, scalar)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
-  const octave_scalar& v2 = dynamic_cast<const octave_scalar&> (a2);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
+  const octave_scalar& v2 = DYNORSTAT_CAST<const octave_scalar&> (a2);
 
   return octave_value (v1.array_value () / v2.double_value ());
 }
@@ -58,8 +58,8 @@
 
 DEFBINOP (ldiv, matrix, scalar)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
-  const octave_scalar& v2 = dynamic_cast<const octave_scalar&> (a2);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
+  const octave_scalar& v2 = DYNORSTAT_CAST<const octave_scalar&> (a2);
 
   Matrix m1 = v1.matrix_value ();
   Matrix m2 = v2.matrix_value ();
@@ -82,8 +82,8 @@
 
 DEFBINOP (el_div, matrix, scalar)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
-  const octave_scalar& v2 = dynamic_cast<const octave_scalar&> (a2);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
+  const octave_scalar& v2 = DYNORSTAT_CAST<const octave_scalar&> (a2);
 
   return octave_value (v1.array_value () / v2.double_value ());
 }
@@ -92,8 +92,8 @@
 
 DEFBINOP (el_ldiv, matrix, scalar)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
-  const octave_scalar& v2 = dynamic_cast<const octave_scalar&> (a2);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
+  const octave_scalar& v2 = DYNORSTAT_CAST<const octave_scalar&> (a2);
 
   return elem_xdiv (v2.double_value (), v1.array_value ());
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-m-scm.cc
--- a/libinterp/operators/op-m-scm.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-m-scm.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -52,9 +52,9 @@
 
 DEFBINOP (div, matrix, sparse_complex_matrix)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
   const octave_sparse_complex_matrix& v2
-    = dynamic_cast<const octave_sparse_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_sparse_complex_matrix&> (a2);
 
   if (v2.rows () == 1 && v2.columns () == 1)
     return octave_value (v1.array_value () / v2.complex_value ());
@@ -77,9 +77,9 @@
 
 DEFBINOP (ldiv, matrix, sparse_complex_matrix)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
   const octave_sparse_complex_matrix& v2
-    = dynamic_cast<const octave_sparse_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_sparse_complex_matrix&> (a2);
   MatrixType typ = v1.matrix_type ();
 
   ComplexMatrix ret = xleftdiv (v1.matrix_value (),
@@ -101,9 +101,9 @@
 
 DEFBINOP (el_pow, matrix, sparse_complex_matrix)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
   const octave_sparse_complex_matrix& v2
-    = dynamic_cast<const octave_sparse_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_sparse_complex_matrix&> (a2);
 
   return octave_value
          (elem_xpow (SparseMatrix (v1.matrix_value ()),
@@ -112,9 +112,9 @@
 
 DEFBINOP (el_ldiv, matrix, sparse_complex_matrix)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
   const octave_sparse_complex_matrix& v2
-    = dynamic_cast<const octave_sparse_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_sparse_complex_matrix&> (a2);
   return octave_value
          (quotient (v2.sparse_complex_matrix_value (), v1.matrix_value ()));
 }
@@ -124,9 +124,9 @@
 
 DEFCATOP (m_scm, matrix, sparse_complex_matrix)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
   const octave_sparse_complex_matrix& v2
-    = dynamic_cast<const octave_sparse_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_sparse_complex_matrix&> (a2);
   SparseMatrix tmp (v1.matrix_value ());
   return octave_value (tmp. concat (v2.sparse_complex_matrix_value (),
                                     ra_idx));
@@ -134,7 +134,7 @@
 
 DEFCONV (sparse_complex_matrix_conv, matrix, sparse_complex_matrix)
 {
-  const octave_matrix& v = dynamic_cast<const octave_matrix&> (a);
+  const octave_matrix& v = DYNORSTAT_CAST<const octave_matrix&> (a);
   return new octave_sparse_complex_matrix
          (SparseComplexMatrix (v.complex_matrix_value ()));
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-m-sm.cc
--- a/libinterp/operators/op-m-sm.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-m-sm.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -51,8 +51,8 @@
 
 DEFBINOP (div, matrix, sparse_matrix)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
-  const octave_sparse_matrix& v2 = dynamic_cast<const octave_sparse_matrix&> (a2);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
+  const octave_sparse_matrix& v2 = DYNORSTAT_CAST<const octave_sparse_matrix&> (a2);
 
   if (v2.rows () == 1 && v2.columns () == 1)
     return octave_value (v1.array_value () / v2.scalar_value ());
@@ -74,8 +74,8 @@
 
 DEFBINOP (ldiv, matrix, sparse_matrix)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
-  const octave_sparse_matrix& v2 = dynamic_cast<const octave_sparse_matrix&> (a2);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
+  const octave_sparse_matrix& v2 = DYNORSTAT_CAST<const octave_sparse_matrix&> (a2);
   MatrixType typ = v1.matrix_type ();
 
   Matrix ret = xleftdiv (v1.matrix_value (), v2.matrix_value (), typ);
@@ -98,8 +98,8 @@
 
 DEFBINOP (el_pow, matrix, sparse_matrix)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
-  const octave_sparse_matrix& v2 = dynamic_cast<const octave_sparse_matrix&> (a2);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
+  const octave_sparse_matrix& v2 = DYNORSTAT_CAST<const octave_sparse_matrix&> (a2);
 
   return octave_value (elem_xpow (SparseMatrix (v1.matrix_value ()),
                                   v2.sparse_matrix_value ()));
@@ -107,8 +107,8 @@
 
 DEFBINOP (el_ldiv, matrix, sparse_matrix)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
-  const octave_sparse_matrix& v2 = dynamic_cast<const octave_sparse_matrix&> (a2);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
+  const octave_sparse_matrix& v2 = DYNORSTAT_CAST<const octave_sparse_matrix&> (a2);
 
   return octave_value
          (quotient (v2.sparse_matrix_value (), v1.matrix_value ()));
@@ -119,15 +119,15 @@
 
 DEFCATOP (m_sm, matrix, sparse_matrix)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
-  const octave_sparse_matrix& v2 = dynamic_cast<const octave_sparse_matrix&> (a2);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
+  const octave_sparse_matrix& v2 = DYNORSTAT_CAST<const octave_sparse_matrix&> (a2);
   SparseMatrix tmp (v1.matrix_value ());
   return octave_value (tmp. concat (v2.sparse_matrix_value (), ra_idx));
 }
 
 DEFCONV (sparse_matrix_conv, matrix, sparse_matrix)
 {
-  const octave_matrix& v = dynamic_cast<const octave_matrix&> (a);
+  const octave_matrix& v = DYNORSTAT_CAST<const octave_matrix&> (a);
   return new octave_sparse_matrix (SparseMatrix (v.matrix_value ()));
 }
 
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-mi.cc
--- a/libinterp/operators/op-mi.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-mi.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -47,7 +47,7 @@
 static octave_value
 oct_unop_unsigned_uplus (const octave_base_value& a)
 {
-  const octave_magic_uint& v = dynamic_cast<const octave_magic_uint&> (a);
+  const octave_magic_uint& v = DYNORSTAT_CAST<const octave_magic_uint&> (a);
   // no-op.
   // FIXME: but can we do this just by incrementing the reference count?
   return octave_value (v.clone ());
@@ -56,7 +56,7 @@
 static octave_value
 oct_unop_unsigned_uminus (const octave_base_value& a)
 {
-  const octave_magic_uint& v = dynamic_cast<const octave_magic_uint&> (a);
+  const octave_magic_uint& v = DYNORSTAT_CAST<const octave_magic_uint&> (a);
 
   // We are storing a uint64 value, so some fakery is needed here.
   // Is there a better way?
@@ -96,7 +96,7 @@
 static octave_value
 oct_unop_signed_uplus (const octave_base_value& a)
 {
-  const octave_magic_int& v = dynamic_cast<const octave_magic_int&> (a);
+  const octave_magic_int& v = DYNORSTAT_CAST<const octave_magic_int&> (a);
   // no-op.
   // FIXME: but can we do this just by incrementing the reference count?
   return octave_value (v.clone ());
@@ -105,7 +105,7 @@
 static octave_value
 oct_unop_signed_uminus (const octave_base_value& a)
 {
-  const octave_magic_int& v = dynamic_cast<const octave_magic_int&> (a);
+  const octave_magic_int& v = DYNORSTAT_CAST<const octave_magic_int&> (a);
 
   // FIXME: Maybe there should also be octave_magic_int::as_TYPE_value
   // functions?
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-pm-pm.cc
--- a/libinterp/operators/op-pm-pm.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-pm-pm.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -41,7 +41,7 @@
 
 DEFUNOP (transpose, perm_matrix)
 {
-  const octave_perm_matrix& v = dynamic_cast<const octave_perm_matrix&> (a);
+  const octave_perm_matrix& v = DYNORSTAT_CAST<const octave_perm_matrix&> (a);
   return octave_value (v.perm_matrix_value ().transpose ());
 }
 
@@ -49,31 +49,31 @@
 
 DEFBINOP (div, perm_matrix, perm_matrix)
 {
-  const octave_perm_matrix& v1 = dynamic_cast<const octave_perm_matrix&> (a1);
-  const octave_perm_matrix& v2 = dynamic_cast<const octave_perm_matrix&> (a2);
+  const octave_perm_matrix& v1 = DYNORSTAT_CAST<const octave_perm_matrix&> (a1);
+  const octave_perm_matrix& v2 = DYNORSTAT_CAST<const octave_perm_matrix&> (a2);
 
   return (v1.perm_matrix_value () * v2.perm_matrix_value ().inverse ());
 }
 
 DEFBINOP (ldiv, perm_matrix, perm_matrix)
 {
-  const octave_perm_matrix& v1 = dynamic_cast<const octave_perm_matrix&> (a1);
-  const octave_perm_matrix& v2 = dynamic_cast<const octave_perm_matrix&> (a2);
+  const octave_perm_matrix& v1 = DYNORSTAT_CAST<const octave_perm_matrix&> (a1);
+  const octave_perm_matrix& v2 = DYNORSTAT_CAST<const octave_perm_matrix&> (a2);
 
   return (v1.perm_matrix_value ().inverse () * v2.perm_matrix_value ());
 }
 
 DEFBINOP (pow, perm_matrix, scalar)
 {
-  const octave_perm_matrix& v1 = dynamic_cast<const octave_perm_matrix&> (a1);
-  const octave_scalar& v2 = dynamic_cast<const octave_scalar&> (a2);
+  const octave_perm_matrix& v1 = DYNORSTAT_CAST<const octave_perm_matrix&> (a1);
+  const octave_scalar& v2 = DYNORSTAT_CAST<const octave_scalar&> (a2);
 
   return xpow (v1.perm_matrix_value (), v2.scalar_value ());
 }
 
 CONVDECL (perm_matrix_to_matrix)
 {
-  const octave_perm_matrix& v = dynamic_cast<const octave_perm_matrix&> (a);
+  const octave_perm_matrix& v = DYNORSTAT_CAST<const octave_perm_matrix&> (a);
 
   return new octave_matrix (v.matrix_value ());
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-pm-scm.cc
--- a/libinterp/operators/op-pm-scm.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-pm-scm.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -42,9 +42,9 @@
 
 DEFBINOP (mul_pm_scm, perm_matrix, sparse_complex_matrix)
 {
-  const octave_perm_matrix& v1 = dynamic_cast<const octave_perm_matrix&> (a1);
+  const octave_perm_matrix& v1 = DYNORSTAT_CAST<const octave_perm_matrix&> (a1);
   const octave_sparse_complex_matrix& v2
-    = dynamic_cast<const octave_sparse_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_sparse_complex_matrix&> (a2);
 
   if (v2.rows () == 1 && v2.columns () == 1)
     {
@@ -60,9 +60,9 @@
 
 DEFBINOP (ldiv_pm_scm, perm_matrix, sparse_complex_matrix)
 {
-  const octave_perm_matrix& v1 = dynamic_cast<const octave_perm_matrix&> (a1);
+  const octave_perm_matrix& v1 = DYNORSTAT_CAST<const octave_perm_matrix&> (a1);
   const octave_sparse_complex_matrix& v2
-    = dynamic_cast<const octave_sparse_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_sparse_complex_matrix&> (a2);
 
   return v1.perm_matrix_value ().inverse () * v2.sparse_complex_matrix_value ();
 }
@@ -72,8 +72,8 @@
 DEFBINOP (mul_scm_pm, sparse_complex_matrix, perm_matrix)
 {
   const octave_sparse_complex_matrix& v1
-    = dynamic_cast<const octave_sparse_complex_matrix&> (a1);
-  const octave_perm_matrix& v2 = dynamic_cast<const octave_perm_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_sparse_complex_matrix&> (a1);
+  const octave_perm_matrix& v2 = DYNORSTAT_CAST<const octave_perm_matrix&> (a2);
 
   if (v1.rows () == 1 && v1.columns () == 1)
     {
@@ -90,8 +90,8 @@
 DEFBINOP (div_scm_pm, sparse_complex_matrix, perm_matrix)
 {
   const octave_sparse_complex_matrix& v1
-    = dynamic_cast<const octave_sparse_complex_matrix&> (a1);
-  const octave_perm_matrix& v2 = dynamic_cast<const octave_perm_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_sparse_complex_matrix&> (a1);
+  const octave_perm_matrix& v2 = DYNORSTAT_CAST<const octave_perm_matrix&> (a2);
 
   return v1.sparse_complex_matrix_value () * v2.perm_matrix_value ().inverse ();
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-pm-sm.cc
--- a/libinterp/operators/op-pm-sm.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-pm-sm.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -42,8 +42,8 @@
 
 DEFBINOP (mul_pm_sm, perm_matrix, sparse_matrix)
 {
-  const octave_perm_matrix& v1 = dynamic_cast<const octave_perm_matrix&> (a1);
-  const octave_sparse_matrix& v2 = dynamic_cast<const octave_sparse_matrix&> (a2);
+  const octave_perm_matrix& v1 = DYNORSTAT_CAST<const octave_perm_matrix&> (a1);
+  const octave_sparse_matrix& v2 = DYNORSTAT_CAST<const octave_sparse_matrix&> (a2);
 
   if (v2.rows () == 1 && v2.columns () == 1)
     {
@@ -59,8 +59,8 @@
 
 DEFBINOP (ldiv_pm_sm, perm_matrix, sparse_matrix)
 {
-  const octave_perm_matrix& v1 = dynamic_cast<const octave_perm_matrix&> (a1);
-  const octave_sparse_matrix& v2 = dynamic_cast<const octave_sparse_matrix&> (a2);
+  const octave_perm_matrix& v1 = DYNORSTAT_CAST<const octave_perm_matrix&> (a1);
+  const octave_sparse_matrix& v2 = DYNORSTAT_CAST<const octave_sparse_matrix&> (a2);
 
   return v1.perm_matrix_value ().inverse () * v2.sparse_matrix_value ();
 }
@@ -69,8 +69,8 @@
 
 DEFBINOP (mul_sm_pm, sparse_matrix, perm_matrix)
 {
-  const octave_sparse_matrix& v1 = dynamic_cast<const octave_sparse_matrix&> (a1);
-  const octave_perm_matrix& v2 = dynamic_cast<const octave_perm_matrix&> (a2);
+  const octave_sparse_matrix& v1 = DYNORSTAT_CAST<const octave_sparse_matrix&> (a1);
+  const octave_perm_matrix& v2 = DYNORSTAT_CAST<const octave_perm_matrix&> (a2);
 
   if (v1.rows () == 1 && v1.columns () == 1)
     {
@@ -86,8 +86,8 @@
 
 DEFBINOP (div_sm_pm, sparse_matrix, perm_matrix)
 {
-  const octave_sparse_matrix& v1 = dynamic_cast<const octave_sparse_matrix&> (a1);
-  const octave_perm_matrix& v2 = dynamic_cast<const octave_perm_matrix&> (a2);
+  const octave_sparse_matrix& v1 = DYNORSTAT_CAST<const octave_sparse_matrix&> (a1);
+  const octave_perm_matrix& v2 = DYNORSTAT_CAST<const octave_perm_matrix&> (a2);
 
   return v1.sparse_matrix_value () * v2.perm_matrix_value ().inverse ();
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-pm-template.cc
--- a/libinterp/operators/op-pm-template.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-pm-template.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -57,8 +57,8 @@
 
 DEFBINOP (mul, LMATRIX, RMATRIX)
 {
-  const OCTAVE_LMATRIX& v1 = dynamic_cast<const OCTAVE_LMATRIX&> (a1);
-  const OCTAVE_RMATRIX& v2 = dynamic_cast<const OCTAVE_RMATRIX&> (a2);
+  const OCTAVE_LMATRIX& v1 = DYNORSTAT_CAST<const OCTAVE_LMATRIX&> (a1);
+  const OCTAVE_RMATRIX& v2 = DYNORSTAT_CAST<const OCTAVE_RMATRIX&> (a2);
 
   return v1.LMATRIX_VALUE () * v2.RMATRIX_VALUE ();
 }
@@ -66,16 +66,16 @@
 #if defined (LEFT)
 DEFBINOP (ldiv, LMATRIX, RMATRIX)
 {
-  const OCTAVE_LMATRIX& v1 = dynamic_cast<const OCTAVE_LMATRIX&> (a1);
-  const OCTAVE_RMATRIX& v2 = dynamic_cast<const OCTAVE_RMATRIX&> (a2);
+  const OCTAVE_LMATRIX& v1 = DYNORSTAT_CAST<const OCTAVE_LMATRIX&> (a1);
+  const OCTAVE_RMATRIX& v2 = DYNORSTAT_CAST<const OCTAVE_RMATRIX&> (a2);
 
   return v1.perm_matrix_value ().inverse () * v2.RMATRIX_VALUE ();
 }
 #else
 DEFBINOP (div, LMATRIX, RMATRIX)
 {
-  const OCTAVE_LMATRIX& v1 = dynamic_cast<const OCTAVE_LMATRIX&> (a1);
-  const OCTAVE_RMATRIX& v2 = dynamic_cast<const OCTAVE_RMATRIX&> (a2);
+  const OCTAVE_LMATRIX& v1 = DYNORSTAT_CAST<const OCTAVE_LMATRIX&> (a1);
+  const OCTAVE_RMATRIX& v2 = DYNORSTAT_CAST<const OCTAVE_RMATRIX&> (a2);
 
   return v1.LMATRIX_VALUE () * v2.perm_matrix_value ().inverse ();
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-range.cc
--- a/libinterp/operators/op-range.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-range.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -43,7 +43,7 @@
 
 CONVDECL (range_to_matrix)
 {
-  const octave_range& v = dynamic_cast<const octave_range&> (a);
+  const octave_range& v = DYNORSTAT_CAST<const octave_range&> (a);
 
   return new octave_matrix (v.array_value ());
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-s-cm.cc
--- a/libinterp/operators/op-s-cm.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-s-cm.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -54,9 +54,9 @@
 
 DEFBINOP (div, scalar, complex_matrix)
 {
-  const octave_scalar& v1 = dynamic_cast<const octave_scalar&> (a1);
+  const octave_scalar& v1 = DYNORSTAT_CAST<const octave_scalar&> (a1);
   const octave_complex_matrix& v2
-    = dynamic_cast<const octave_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a2);
 
   Matrix m1 = v1.matrix_value ();
   ComplexMatrix m2 = v2.complex_matrix_value ();
@@ -72,9 +72,9 @@
 
 DEFBINOP (ldiv, scalar, complex_matrix)
 {
-  const octave_scalar& v1 = dynamic_cast<const octave_scalar&> (a1);
+  const octave_scalar& v1 = DYNORSTAT_CAST<const octave_scalar&> (a1);
   const octave_complex_matrix& v2
-    = dynamic_cast<const octave_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a2);
 
   return octave_value (v2.complex_array_value () / v1.double_value ());
 }
@@ -92,9 +92,9 @@
 
 DEFBINOP (el_ldiv, scalar, complex_matrix)
 {
-  const octave_scalar& v1 = dynamic_cast<const octave_scalar&> (a1);
+  const octave_scalar& v1 = DYNORSTAT_CAST<const octave_scalar&> (a1);
   const octave_complex_matrix& v2
-    = dynamic_cast<const octave_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a2);
 
   return octave_value (v2.complex_array_value () / v1.double_value ());
 }
@@ -106,7 +106,7 @@
 
 DEFCONV (complex_matrix_conv, scalar, complex_matrix)
 {
-  const octave_scalar& v = dynamic_cast<const octave_scalar&> (a);
+  const octave_scalar& v = DYNORSTAT_CAST<const octave_scalar&> (a);
 
   return new octave_complex_matrix (ComplexMatrix (v.matrix_value ()));
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-s-cs.cc
--- a/libinterp/operators/op-s-cs.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-s-cs.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -49,8 +49,8 @@
 
 DEFBINOP (div, scalar, complex)
 {
-  const octave_scalar& v1 = dynamic_cast<const octave_scalar&> (a1);
-  const octave_complex& v2 = dynamic_cast<const octave_complex&> (a2);
+  const octave_scalar& v1 = DYNORSTAT_CAST<const octave_scalar&> (a1);
+  const octave_complex& v2 = DYNORSTAT_CAST<const octave_complex&> (a2);
 
   return octave_value (v1.double_value () / v2.complex_value ());
 }
@@ -59,8 +59,8 @@
 
 DEFBINOP (ldiv, scalar, complex)
 {
-  const octave_scalar& v1 = dynamic_cast<const octave_scalar&> (a1);
-  const octave_complex& v2 = dynamic_cast<const octave_complex&> (a2);
+  const octave_scalar& v1 = DYNORSTAT_CAST<const octave_scalar&> (a1);
+  const octave_complex& v2 = DYNORSTAT_CAST<const octave_complex&> (a2);
 
   return octave_value (v2.complex_value () / v1.double_value ());
 }
@@ -76,8 +76,8 @@
 
 DEFBINOP (el_div, scalar, complex)
 {
-  const octave_scalar& v1 = dynamic_cast<const octave_scalar&> (a1);
-  const octave_complex& v2 = dynamic_cast<const octave_complex&> (a2);
+  const octave_scalar& v1 = DYNORSTAT_CAST<const octave_scalar&> (a1);
+  const octave_complex& v2 = DYNORSTAT_CAST<const octave_complex&> (a2);
 
   return octave_value (v1.double_value () / v2.complex_value ());
 }
@@ -86,24 +86,24 @@
 
 DEFBINOP (el_ldiv, scalar, complex)
 {
-  const octave_scalar& v1 = dynamic_cast<const octave_scalar&> (a1);
-  const octave_complex& v2 = dynamic_cast<const octave_complex&> (a2);
+  const octave_scalar& v1 = DYNORSTAT_CAST<const octave_scalar&> (a1);
+  const octave_complex& v2 = DYNORSTAT_CAST<const octave_complex&> (a2);
 
   return octave_value (v2.complex_value () / v1.double_value ());
 }
 
 DEFBINOP (el_and, scalar, complex)
 {
-  const octave_scalar& v1 = dynamic_cast<const octave_scalar&> (a1);
-  const octave_complex& v2 = dynamic_cast<const octave_complex&> (a2);
+  const octave_scalar& v1 = DYNORSTAT_CAST<const octave_scalar&> (a1);
+  const octave_complex& v2 = DYNORSTAT_CAST<const octave_complex&> (a2);
 
   return octave_value (v1.double_value () && (v2.complex_value () != 0.0));
 }
 
 DEFBINOP (el_or, scalar, complex)
 {
-  const octave_scalar& v1 = dynamic_cast<const octave_scalar&> (a1);
-  const octave_complex& v2 = dynamic_cast<const octave_complex&> (a2);
+  const octave_scalar& v1 = DYNORSTAT_CAST<const octave_scalar&> (a1);
+  const octave_complex& v2 = DYNORSTAT_CAST<const octave_complex&> (a2);
 
   return octave_value (v1.double_value () || (v2.complex_value () != 0.0));
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-s-m.cc
--- a/libinterp/operators/op-s-m.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-s-m.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -48,8 +48,8 @@
 
 DEFBINOP (div, scalar, matrix)
 {
-  const octave_scalar& v1 = dynamic_cast<const octave_scalar&> (a1);
-  const octave_matrix& v2 = dynamic_cast<const octave_matrix&> (a2);
+  const octave_scalar& v1 = DYNORSTAT_CAST<const octave_scalar&> (a1);
+  const octave_matrix& v2 = DYNORSTAT_CAST<const octave_matrix&> (a2);
 
   Matrix m1 = v1.matrix_value ();
   Matrix m2 = v2.matrix_value ();
@@ -65,8 +65,8 @@
 
 DEFBINOP (ldiv, scalar, matrix)
 {
-  const octave_scalar& v1 = dynamic_cast<const octave_scalar&> (a1);
-  const octave_matrix& v2 = dynamic_cast<const octave_matrix&> (a2);
+  const octave_scalar& v1 = DYNORSTAT_CAST<const octave_scalar&> (a1);
+  const octave_matrix& v2 = DYNORSTAT_CAST<const octave_matrix&> (a2);
 
   return octave_value (v2.array_value () / v1.double_value ());
 }
@@ -84,8 +84,8 @@
 
 DEFBINOP (el_ldiv, scalar, matrix)
 {
-  const octave_scalar& v1 = dynamic_cast<const octave_scalar&> (a1);
-  const octave_matrix& v2 = dynamic_cast<const octave_matrix&> (a2);
+  const octave_scalar& v1 = DYNORSTAT_CAST<const octave_scalar&> (a1);
+  const octave_matrix& v2 = DYNORSTAT_CAST<const octave_matrix&> (a2);
 
   return octave_value (v2.array_value () / v1.double_value ());
 }
@@ -97,7 +97,7 @@
 
 DEFCONV (matrix_conv, scalar, matrix)
 {
-  const octave_scalar& v = dynamic_cast<const octave_scalar&> (a);
+  const octave_scalar& v = DYNORSTAT_CAST<const octave_scalar&> (a);
 
   return new octave_matrix (v.matrix_value ());
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-s-s.cc
--- a/libinterp/operators/op-s-s.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-s-s.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -47,7 +47,7 @@
 
 DEFUNOP (not, scalar)
 {
-  const octave_scalar& v = dynamic_cast<const octave_scalar&> (a);
+  const octave_scalar& v = DYNORSTAT_CAST<const octave_scalar&> (a);
   double x = v.scalar_value ();
   if (octave::math::isnan (x))
     octave::err_nan_to_logical_conversion ();
@@ -71,8 +71,8 @@
 
 DEFBINOP (div, scalar, scalar)
 {
-  const octave_scalar& v1 = dynamic_cast<const octave_scalar&> (a1);
-  const octave_scalar& v2 = dynamic_cast<const octave_scalar&> (a2);
+  const octave_scalar& v1 = DYNORSTAT_CAST<const octave_scalar&> (a1);
+  const octave_scalar& v2 = DYNORSTAT_CAST<const octave_scalar&> (a2);
 
   return octave_value (v1.double_value () / v2.double_value ());
 }
@@ -81,8 +81,8 @@
 
 DEFBINOP (ldiv, scalar, scalar)
 {
-  const octave_scalar& v1 = dynamic_cast<const octave_scalar&> (a1);
-  const octave_scalar& v2 = dynamic_cast<const octave_scalar&> (a2);
+  const octave_scalar& v1 = DYNORSTAT_CAST<const octave_scalar&> (a1);
+  const octave_scalar& v2 = DYNORSTAT_CAST<const octave_scalar&> (a2);
 
   return octave_value (v2.double_value () / v1.double_value ());
 }
@@ -98,8 +98,8 @@
 
 DEFBINOP (el_div, scalar, scalar)
 {
-  const octave_scalar& v1 = dynamic_cast<const octave_scalar&> (a1);
-  const octave_scalar& v2 = dynamic_cast<const octave_scalar&> (a2);
+  const octave_scalar& v1 = DYNORSTAT_CAST<const octave_scalar&> (a1);
+  const octave_scalar& v2 = DYNORSTAT_CAST<const octave_scalar&> (a2);
 
   return octave_value (v1.double_value () / v2.double_value ());
 }
@@ -108,8 +108,8 @@
 
 DEFBINOP (el_ldiv, scalar, scalar)
 {
-  const octave_scalar& v1 = dynamic_cast<const octave_scalar&> (a1);
-  const octave_scalar& v2 = dynamic_cast<const octave_scalar&> (a2);
+  const octave_scalar& v1 = DYNORSTAT_CAST<const octave_scalar&> (a1);
+  const octave_scalar& v2 = DYNORSTAT_CAST<const octave_scalar&> (a2);
 
   return octave_value (v2.double_value () / v1.double_value ());
 }
